"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GermlineSample(ProtocolElement):
    """
    A germline sample
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "LDPCode",
        "labSampleId",
        "sampleId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import participant as participant_1_1_2

        return {
            "preparationMethod": participant_1_1_2.PreparationMethod,
            "product": participant_1_1_2.Product,
            "programmePhase": participant_1_1_2.ProgrammePhase,
            "source": participant_1_1_2.SampleSource,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import participant as participant_1_1_2

        return {
            "org.gel.models.participant.avro.PreparationMethod": participant_1_1_2.PreparationMethod,
            "org.gel.models.participant.avro.Product": participant_1_1_2.Product,
            "org.gel.models.participant.avro.ProgrammePhase": participant_1_1_2.ProgrammePhase,
            "org.gel.models.participant.avro.SampleSource": participant_1_1_2.SampleSource,
            "org.gel.models.participant.avro.GermlineSample": participant_1_1_2.GermlineSample,
        }

    __slots__ = [
        "LDPCode",
        "labSampleId",
        "sampleId",
        "clinicalSampleDateTime",
        "preparationMethod",
        "product",
        "programmePhase",
        "source",
    ]

    def __init__(
        self,
        LDPCode,
        labSampleId,
        sampleId,
        clinicalSampleDateTime=None,
        preparationMethod=None,
        product=None,
        programmePhase=None,
        source=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_1_2.GermlineSample model.

        :param LDPCode:
            LDP Code (Local Delivery Partner)
        :type LDPCode: str
        :param labSampleId:
            Lab sample identifier
        :type labSampleId: int
        :param sampleId:
            Sample identifier (e.g, LP00012645_5GH))
        :type sampleId: str
        :param clinicalSampleDateTime:
            The time when the sample was received. In the format
            YYYY-MM-DDTHH:MM:SS+0000
        :type clinicalSampleDateTime: None | str
        :param preparationMethod:
            Preparation method
        :type preparationMethod: None | PreparationMethod
        :param product:
            Product of the sample
        :type product: None | Product
        :param programmePhase:
            Genomics England programme phase
        :type programmePhase: None | ProgrammePhase
        :param source:
            Source of the sample
        :type source: None | SampleSource
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.1.2"
